#!/usr/bin/perl
print "\nGentoo XML-QA-checker called.  In case of troubles, please file a bug for the GDP team.\n\n";
my $VALID_EXT = 'xml|xsl|txt|pdf|html|rdf|dtd|log|sxi|css|png|jpg|gif|tar|gz|bz2|ico|sql|svg';
foreach ( @ARGV ) {
	if ( -e $_ ) {
		unless ( -d $_ ) {
			if ( -f $_ and $_ =~ /((\.($VALID_EXT))|changelog|docutils.conf|makefile)$/i ) {
				if ( -x $_ ) {
					print "Do not commit an executable file!\n";
					print "Remove the executable bit locally and commit again.\n\n";
					exit(1);
				}
				if ( $_ =~ /\.xml$/ ) {
					print "XML-Checking $_ ... ";
					unless ( system( "XML_CATALOG_FILES=\"/etc/xml/guidexml\" xmllint --valid --noout $_" ) == 0 ) {
						print "[ failed ]\n\n";
						exit(1);
					}
					print "[ done ]\n\n";
				}
				elsif ( $_ =~ /\.xsl$/ ) {
					print "XSL-Checking $_ ... ";
					unless ( system( "xmllint --noout $_" ) == 0 ) {
						print "[ failed ]\n\n";
						exit(1);
					}
					print "[ done ]\n\n";
				}
			}
			else {
				print "That file you are about to commit is not allowed.\n";
				print "Allowed filetypes are:\n";
				print "$VALID_EXT, changelog, docutils.conf, makefile\n\n";
				print "If you need to commit another filetype, please file a bug to\n";
				print "the Infrastructure team.\n\n";
				exit(1);
			}
		}
	}
}
#EOF vim: tabstop=2
