#!/usr/bin/perl
use strict;
use warnings;
use File::Spec;
use File::stat;

my $repo = shift @ARGV;
my $path = shift @ARGV;
my $user = $ENV{USER};
my $DEBUG = (exists $ENV{DEBUG});

my $ret = 0;

foreach(@ARGV) {
	my $localfilepath = File::Spec->catfile($path, $_);
	my $filepath = File::Spec->catfile($repo, $localfilepath).',v';
	print STDERR "repo=$repo path=$path file=$_\n" if $DEBUG;
	#-f $filepath or die "$filepath does not exist.";
	-f $filepath or next;
	my $sb = stat($filepath);
	my ($groupname,$grouppasswd,$groupgid,$groupmembers) = getgrgid($sb->gid);
	my @groupmembers = split /[, ]/,$groupmembers;
	print STDERR 'groupmembers ('.join(',', @groupmembers).")\n" if $DEBUG;
	my @valid = grep /^$user$/, @groupmembers;
	print STDERR '@valid ('.join(',', @valid).")\n" if $DEBUG;
	my $valid = (scalar @valid) > 0;
	print STDERR 'array ('.join(',', @valid).") $valid\n" if $DEBUG;
	if($valid) { $valid = $valid[0] eq $user; }
	printf STDERR "File is %s, size is %s, perm %04o, mtime %s, group %s, valid for $user %d\n",
		   $filepath, $sb->size, $sb->mode & 07777,
		   scalar localtime $sb->mtime, $groupname, $valid if $DEBUG;
	if(!$valid) {
		printf STDERR "You do not have permissions to commit to %s\n", $localfilepath;
		$ret = 1;
	}
}
exit $ret;
